<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: PWM Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classPWM-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">PWM Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A wrapper for ESP32 PWM control.  
 <a href="classPWM.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="PWM_8h_source.html">PWM.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa26673999e30f8cd236b3cc3b1f890bd"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPWM.html#aa26673999e30f8cd236b3cc3b1f890bd">PWM</a> (int gpioNum, uint32_t frequency=100, ledc_timer_bit_t bitSize=LEDC_TIMER_10_BIT, ledc_timer_t timer=LEDC_TIMER_0, ledc_channel_t channel=LEDC_CHANNEL_0)</td></tr>
<tr class="memdesc:aa26673999e30f8cd236b3cc3b1f890bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct an instance.  <a href="#aa26673999e30f8cd236b3cc3b1f890bd">More...</a><br /></td></tr>
<tr class="separator:aa26673999e30f8cd236b3cc3b1f890bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d6403597b936f73be3a53b330d15f52"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPWM.html#a7d6403597b936f73be3a53b330d15f52">getDuty</a> ()</td></tr>
<tr class="memdesc:a7d6403597b936f73be3a53b330d15f52"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the duty cycle value.  <a href="#a7d6403597b936f73be3a53b330d15f52">More...</a><br /></td></tr>
<tr class="separator:a7d6403597b936f73be3a53b330d15f52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70e2e1ad7736f241eef020ec4c7e7fff"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPWM.html#a70e2e1ad7736f241eef020ec4c7e7fff">getFrequency</a> ()</td></tr>
<tr class="memdesc:a70e2e1ad7736f241eef020ec4c7e7fff"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the frequency/period in Hz.  <a href="#a70e2e1ad7736f241eef020ec4c7e7fff">More...</a><br /></td></tr>
<tr class="separator:a70e2e1ad7736f241eef020ec4c7e7fff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adae9be9a8c34c42d0f81dd0b4a24c14f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPWM.html#adae9be9a8c34c42d0f81dd0b4a24c14f">setDuty</a> (uint32_t duty)</td></tr>
<tr class="memdesc:adae9be9a8c34c42d0f81dd0b4a24c14f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the duty cycle value.  <a href="#adae9be9a8c34c42d0f81dd0b4a24c14f">More...</a><br /></td></tr>
<tr class="separator:adae9be9a8c34c42d0f81dd0b4a24c14f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2a9dd4cbe6349d420eef610e8909011"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPWM.html#ab2a9dd4cbe6349d420eef610e8909011">setDutyPercentage</a> (uint8_t percent)</td></tr>
<tr class="memdesc:ab2a9dd4cbe6349d420eef610e8909011"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the duty cycle as a percentage value.  <a href="#ab2a9dd4cbe6349d420eef610e8909011">More...</a><br /></td></tr>
<tr class="separator:ab2a9dd4cbe6349d420eef610e8909011"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a51543c5bf29d9f3ae83c7f5af176895d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPWM.html#a51543c5bf29d9f3ae83c7f5af176895d">setFrequency</a> (uint32_t freq)</td></tr>
<tr class="memdesc:a51543c5bf29d9f3ae83c7f5af176895d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the frequency/period in Hz.  <a href="#a51543c5bf29d9f3ae83c7f5af176895d">More...</a><br /></td></tr>
<tr class="separator:a51543c5bf29d9f3ae83c7f5af176895d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a839027de87bbee57a3dabe21d254d892"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPWM.html#a839027de87bbee57a3dabe21d254d892">stop</a> (bool idleLevel=false)</td></tr>
<tr class="memdesc:a839027de87bbee57a3dabe21d254d892"><td class="mdescLeft">&#160;</td><td class="mdescRight">Stop the PWM.  <a href="#a839027de87bbee57a3dabe21d254d892">More...</a><br /></td></tr>
<tr class="separator:a839027de87bbee57a3dabe21d254d892"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A wrapper for ESP32 PWM control. </p>
<p>Pulse Width Modulation (PWM) is known as "LEDC" in the ESP32. It allows us to set a repeating clock signal. There are two aspects to the signal called the frequency and duty cycle. The frequency is how many times per second the signal repeats. The duty cycle is how much of a single period the output signal is high compared to low. For example, a duty cycle of 0% means that the signal is always low, while a duty cycle of 100% means the signal is always high. A duty cycle of 50% means that the signal is high for 50% of the output and low for the remaining 50%. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aa26673999e30f8cd236b3cc3b1f890bd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa26673999e30f8cd236b3cc3b1f890bd">&#9670;&nbsp;</a></span>PWM()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PWM::PWM </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>gpioNum</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>frequency</em> = <code>100</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ledc_timer_bit_t&#160;</td>
          <td class="paramname"><em>dutyResolution</em> = <code>LEDC_TIMER_10_BIT</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ledc_timer_t&#160;</td>
          <td class="paramname"><em>timer</em> = <code>LEDC_TIMER_0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ledc_channel_t&#160;</td>
          <td class="paramname"><em>channel</em> = <code>LEDC_CHANNEL_0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct an instance. </p>
<p>A timer starts ticking up from 0 to the maximum value of the bit size. When it reaches the maximum value, it resets.</p>
<p>In the following example, we create a signal that has a frequency of 100Hz and is a square wave (50% on, 50% off).</p>
<div class="fragment"><div class="line"><a class="code" href="classPWM.html">PWM</a> pwm(GPIO_NUM_21);</div><div class="line">pwm.setDutyPercentage(50);</div><div class="line">pwm.setFrequency(100);</div></div><!-- fragment --><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">gpioNum</td><td>The GPIO pin to use for output. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">frequency</td><td>The frequency of the period. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dutyResolution</td><td>The size in bits of the timer. Allowed values are LEDC_TIMER_10_BIT, LEDC_TIMER_11_BIT, LEDC_TIMER_12_BIT, LEDC_TIMER_13_BIT, LEDC_TIMER_14_BIT, LEDC_TIMER_15_BIT. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">timer</td><td>The timer to use. A value of LEDC_TIMER0, LEDC_TIMER1, LEDC_TIMER2 or LEDC_TIMER3. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">channel</td><td>The channel to use. A value from LEDC_CHANNEL0 to LEDC_CHANNEL1.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a7d6403597b936f73be3a53b330d15f52"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7d6403597b936f73be3a53b330d15f52">&#9670;&nbsp;</a></span>getDuty()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t PWM::getDuty </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the duty cycle value. </p>
<dl class="section return"><dt>Returns</dt><dd>The duty cycle value. </dd></dl>

</div>
</div>
<a id="a70e2e1ad7736f241eef020ec4c7e7fff"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a70e2e1ad7736f241eef020ec4c7e7fff">&#9670;&nbsp;</a></span>getFrequency()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t PWM::getFrequency </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the frequency/period in Hz. </p>
<dl class="section return"><dt>Returns</dt><dd>The frequency/period in Hz. </dd></dl>

</div>
</div>
<a id="adae9be9a8c34c42d0f81dd0b4a24c14f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adae9be9a8c34c42d0f81dd0b4a24c14f">&#9670;&nbsp;</a></span>setDuty()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PWM::setDuty </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>duty</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the duty cycle value. </p>
<p>The duty cycle value is a numeric between 0 and the maximum bit size. When the PWM tick value is less than this value, the output is high while when it is higher than this value, the output is low. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">duty</td><td>The duty cycle value. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ab2a9dd4cbe6349d420eef610e8909011"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab2a9dd4cbe6349d420eef610e8909011">&#9670;&nbsp;</a></span>setDutyPercentage()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PWM::setDutyPercentage </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>percent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the duty cycle as a percentage value. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">percent</td><td>The percentage of the duty cycle (0-100). </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a51543c5bf29d9f3ae83c7f5af176895d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a51543c5bf29d9f3ae83c7f5af176895d">&#9670;&nbsp;</a></span>setFrequency()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PWM::setFrequency </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>freq</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the frequency/period in Hz. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">freq</td><td>The frequency to set the PWM. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a839027de87bbee57a3dabe21d254d892"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a839027de87bbee57a3dabe21d254d892">&#9670;&nbsp;</a></span>stop()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PWM::stop </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>idleLevel</em> = <code>false</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Stop the PWM. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">idleLevel</td><td>The level to leave the output after end. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="PWM_8h_source.html">PWM.h</a></li>
<li>PWM.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
